/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package test;

import java.io.IOException;
import org.apache.log4j.Logger;
import org.infinispan.Cache;
import org.infinispan.manager.DefaultCacheManager;
import org.infinispan.transaction.tm.DummyTransactionManager;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import org.junit.BeforeClass;

/**
 *
 */
public class TestReplace {

    @BeforeClass
    public static void init() {
        System.setProperty("java.net.preferIPv4Stack", "true");
    }
    Cache cache;
    Cache cacheRepl;
    Cache cacheB;
    Cache cacheReplB;
    volatile boolean running = true;
    DefaultCacheManager cacheManager;
    DefaultCacheManager cacheManagerRepl;
    DummyTransactionManager transactionManager = new DummyTransactionManager();

    @Before
    public void createCache() throws InterruptedException, IOException {
        cacheManager = new org.infinispan.manager.DefaultCacheManager("test-cluster_1.xml");
        cacheManagerRepl = new org.infinispan.manager.DefaultCacheManager("test-cluster_1.xml");
        cacheManager.start();
        cacheManagerRepl.start();

        cache = cacheManager.getCache("TEST_CACHE");
        cacheB = cacheManager.getCache("TEST_CACHE_B");

        cacheRepl = cacheManagerRepl.getCache("TEST_CACHE");
        cacheReplB = cacheManagerRepl.getCache("TEST_CACHE_B");

        Thread.sleep(1000);
    }

    @After
    public void shutdown() {
        cacheManager.stop();
        cacheManagerRepl.stop();
    }

    XThread[] threads;

    @Test
    public void testMultipleThreads() throws InterruptedException {
        
        int count = 1000;
        threads = new XThread[5];
        for (int i = 0; i < threads.length; i++) {
            threads[i] = new XThread(count, i);
            threads[i].start();
        }

        for (int i = 0; i < threads.length; i++) {
            threads[i].join();
        }
        Logger logger = Logger.getLogger(TestReplace.class);
        
        System.out.println("sleep 60 seconds to check jstat");
        Thread.sleep(60000);
        for (int i = 0; i < 60; i++) {
            logger.warn("AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAa");
        }
    }

    class XThread extends Thread {

        private int count;
        private int id;

        public XThread(int count, int id) {
            this.count = count;
            this.id = id;
        }

        @Override
        public void run() {
            for (int i = 0; i < count && running; i++) {
                try {
                    increase(id);
                
                } catch (Exception e) {
                    e.printStackTrace(System.out);
                    System.out.println("Stop all threads because of ERROR");
                    running = false;
                    break;
                }
            }

        }
    }

    private void increase(int i) throws Exception {
        transactionManager.begin();
        try {
            StringKey key = new StringKey("key");
            cache.getAdvancedCache().lock(key);
            Thread.sleep(100);
            transactionManager.commit();
        } catch (Exception e) {
            transactionManager.rollback();
            throw e;
        }

    }
}
